package com.futu.course.orders.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.futu.course.common.utils.SnowflakeIdWorker;
import com.futu.course.orders.domain.Order1;
import com.futu.course.orders.service.Order1Service;
import com.futu.course.orders.mapper.Order1Mapper;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author yuu
 * @description 针对表【order1(订单表)】的数据库操作Service实现
 * @createDate 2025-05-05 18:45:49
 */
@Service
public class Order1ServiceImpl extends ServiceImpl<Order1Mapper, Order1> implements Order1Service {
    /**
     * @title: OrderList
     * @desc:  订单查询
     * @params int status
     * @return: List<Order1>
     * @author: 杨旭朋
     * @date: 2025/5/12 19:39
     */
    public List<Order1> OrderList(int status) {
        SnowflakeIdWorker snowflakeIdWorker = new SnowflakeIdWorker(1, 1);
        long l = snowflakeIdWorker.nextId();
//        long l = 1919928855523627008L;
//        查看指定用户所有的订单
        LambdaQueryWrapper<Order1> eq = Wrappers.<Order1>lambdaQuery()
                .eq(Order1::getUserId, l);
        if (status != 0) {
            eq.eq(Order1::getStatus, status);
            return this.list(eq);
        }
        return this.list(eq);
    }
}




